#ifndef _OPCLIB_TYPES_H
#define _OPCLIB_TYPES_H

typedef void (*OPCDestroyContextFunction)(void *);
typedef void (*OPCReturnFunction)(void *, void *);
typedef int (*OPCSendFunction)(void *ctx, const void *data, unsigned long length);

#define int8 char
#define int16 short int
#define int32 long int
#define int64 long long int
#define uint8 unsigned char
#define uint16 unsigned short int
#define uint32 unsigned long int
#define uint64 unsigned long long int

typedef unsigned long dword;
typedef unsigned int word;

#endif /* _OPCLIB_TYPES_H */
