#ifndef _OPC_ITEM_PROPERTIES_H
#define _OPC_ITEM_PROPERTIES_H

#include <opcmalloc.h>
#include <opcitemproperty.h>

typedef struct OPCItemPropertiesContextT *OPCItemPropertiesContext; 

struct OPCItemPropertiesContextT {
    OPCMallocContext malloc;
    OPCItemPropertyContext *properties;
    unsigned short relocations;
    unsigned short *relocation; /* Just pointer on external source, should be sorted */
};

OPCItemPropertiesContext opcItemPropertiesCreateContext(OPCMallocContext mctx);
int opcItemPropertiesInitContext(OPCItemPropertiesContext ctx, unsigned short properties_maxid);
int opcItemPropertiesInitLimitedContext(OPCItemPropertiesContext ctx, unsigned short size, unsigned short *relocation);
void opcItemPropertiesFreeContext(OPCItemPropertiesContext ctx);
void opcItemPropertiesDestroyContext(OPCItemPropertiesContext ctx);

#endif /* _OPC_ITEM_PROPERTIES_H */
