#define _OPC_QUALITY_C

#include <assert.h>

#include <opcquality.h>



OPCQuality opcQualityCreate(OPCMallocContext mctx, OPCQualityField quality, OPCLimitField limit, uint8 vendor) {
    OPCQuality ctx;
    
    ctx = (OPCQuality)opcMalloc(mctx, sizeof(struct OPCQualityT));
    if (ctx) {
	ctx->quality = quality;
	ctx->limit = limit;
	ctx->vendor = vendor;
    }
}


int opcQualitySet(OPCQuality ctx, OPCQualityField quality, OPCLimitField limit, uint8 vendor) {
    assert(ctx);
    
    ctx->quality = quality;
    ctx->limit = limit;
    ctx->vendor = vendor;
    return 0;
}


int opcQualityCopy(OPCQuality dst, OPCQuality src) {
    assert(dst);
    assert(src);
    
    memcpy(dst, src, sizeof(struct OPCQualityT));
    return 0;
}
