#ifndef _OPC_SERVERINTERFACE_H
#define _OPC_SERVERINTERFACE_H

#include <opc.h>
#include <opcitem.h>

int opcServerStartTimeSet(OPCContext ctx);
int opcServerStateSet(OPCContext ctx, unsigned int state, const char *status_str);
int opcServerVendorInfoSet(OPCContext ctx, const char *vi);
int opcServerVersionSet(OPCContext ctx, const char *major, const char *minor, unsigned long build);
int opcServerInterfaceAdd(OPCContext ctx, const char *interface, const char **extensions);
int opcServerLocalesAdd(OPCContext ctx, const char **locales);
int opcServerInitTree(OPCContext ctx);
int opcServerRegisterItem(OPCContext ctx, OPCItemContext *ictx, const char *path, const char *name);
int opcServerDestroyItem(OPCContext ctx, OPCItemContext ictx);


/*
OPCItemContext opcServerRegisterItem(OPCContext ctx,
	const char *path, 		// Item path
	const char *name, 		// Item name
	const char *datatype, 		// Data type
	const char *config,		// Config Data type ( NULL - disable )
	unsigned long flags, 		// mode(notification,send), cache
	double rate);			// Events per second
					// Locales?
					// Format?
int opcServerFreeItem(OPCItemContext ctx);*/

//int opcServerRegisterItem(OPCContext ctx, const char *path, const char *name);
//void opcServerFreeItem(OPCItemContext ictx);

#endif /* _OPC_SERVERINTERFACE_H */
