#ifndef _OPC_STANDARD_TYPE_H
#define _OPC_STANDARD_TYPE_H

#include <opcmalloc.h>
#include <opctype.h>

typedef enum OPCStandardTypeT OPCStandardType;

enum OPCStandardTypeT {
    OPC_DATATYPE_COMPLEX = 0,
    OPC_DATATYPE_ENUMERATION,
    OPC_DATATYPE_UNSIGNED_CHAR,
    OPC_DATATYPE_UNSIGNED_SHORT,
    OPC_DATATYPE_UNSIGNED,
    OPC_DATATYPE_UNSIGNED_LONG,
    OPC_DATATYPE_CHAR,
    OPC_DATATYPE_SHORT,
    OPC_DATATYPE_INT,
    OPC_DATATYPE_LONG,
    OPC_DATATYPE_FLOAT,
    OPC_DATATYPE_DOUBLE,
    OPC_DATATYPE_STRING,
    OPC_DATATYPE_STRINGLIST,
    OPC_DATATYPE_XML,
    OPC_DATATYPE_QNAME,
    OPC_DATATYPE_DATETIME,
    OPC_DATATYPE_DATE,
    OPC_DATATYPE_TIME
};

OPCType opcStandardType(OPCMallocContext mctx, OPCStandardType datatype, const void *attr);

#endif /* _OPC_DATA_TYPE_H */
