#include <opcerr.h>
#include <opcassert.h>

#include <opcrepresentation.h>

void opcRepresentationUnref(OPCRepresentationContext ctx) {
    if (ctx&&ctx->Unref) ctx->Unref(ctx);
}

int opcRepresentationSetId(OPCRepresentationContext ctx, unsigned short int repid) {
    if (!ctx) return ERR_OPC_PARAM;
    ctx->id = repid;
}

int opcRepresentationDataDataBuffer(OPCRepresentationInfo repinfo, OPCDataBufferContext db) { 
    repinfo->ctx = db;
    repinfo->malloc = NULL;
    repinfo->Send = opcDataBufferSend;
    repinfo->Destroy = NULL;
    repinfo->destructor_type = OPC_DATA_DESTRUCTOR_RETURN;
    repinfo->Destructor = opcDataBufferFree;
    return 0;
}
