#include <stdio.h>
#include <string.h>

#include <opcerr.h>

#include <opcmalloc.h>
#include <lchar.h>


int opcLCharExchangeString(OPCMallocContext mctx, lchar *dst, const char *src) {
    lchar tmp;
    if (!src) {
	if (*dst) opcFree(mctx, *dst);
	return 0;
    }
    tmp = (lchar)opcMalloc(mctx, (strlen(src)+1)*sizeof(char));
    if (!tmp) return ERR_OPC_MEM;
    strcpy(tmp,src);
    if (*dst) opcFree(mctx, *dst);
    *dst=tmp;
    return 0;
}
