#ifndef _OPC_TOOLS_H
#define _OPC_TOOLS_H

#include <time.h>

#include <opcmalloc.h>

int opcExchangeString(OPCMallocContext mctx, char **dst, const char *src);
int opcExchangeStringChars(OPCMallocContext mctx, char **dst, const char *src, unsigned chars);
char *opcCreateFullName(OPCMallocContext mctx, const char *path, const char *filename);
time_t GetFileModificationTime(const char *file);
int *ThreadReturnInt(OPCMallocContext mctx, int err);

#define malloca(size) alloca(size)
#define freea(size)

#endif /*  _OPC_TOOLS_H */
