
function opcCheckError(&$xml) {
    preg_match("/^HTTP\/\d\.\d (\d{3})/",$xml,$m);
    if ($m[1]==200) return 0;
    $err=$m[1];
    preg_match("/<body>(.*)<\/body>/ims",$xml,$m);
    print $m[1];
    return $err;
}

function opcRequest($srv, $request, $binary=null) {
    global $chunk_size;
    
    $url = parse_url($srv);
    if (preg_match("/^https:/",$url["sheme"])) $prefix="ssl://";
    else $prefix="";
    if ($url["port"]) $port=$url["port"];
    else $port="80";
    $fp = fsockopen($prefix . $url["host"],$port);
    if (!$fp) {
	?><p class="error">Error connecting OPC XML-DA server: <?echo $srv;?></p><?
	return NULL;
    }

    fputs($fp,"POST " . $srv . " HTTP/1.0\r\n");
    fputs($fp,"Host: " . $url["host"] . "\r\n");
    fputs($fp,"Content-type: text/xml\r\n");
    fputs($fp,"Content-length: " . strlen($request) . "\r\n\r\n");
    fputs($fp, $request);

    $ret="";
    while(!feof($fp)) {
	$ret.=fgets($fp,$chunk_size);
    }
    fclose($fp);
    $err=opcCheckError($ret);
    if ($err) return null;
    return $ret;
}
