<?
require("xml.php");
require("http.php");

function opcServer() {
    global $HTTP_COOKIE_VARS;
    global $opc_servers;
    
    if ($HTTP_COOKIE_VARS['opc_server']) {
	$srvname=$HTTP_COOKIE_VARS['opc_server'];
	for ($i=0;$opc_servers[$i];$i++)
	    if (strcmp($opc_servers[$i]["title"],$srvname)==0) return $i;
    } 
    return -1;
}


function opcError($out=1) {
    global $opc_error;
    if ($opc_error) {
	if ($out) {
	    ?><div class="error"><?echo $opc_error;?></div><?
	}
	return 1;
    } 
    return 0;
}

function opcRequest($srv, $request, $binary=null) {
    $res=httpRequest(&$srv,&$request, &$binary);
    if (!$res) $GLOBALS['opc_error']=&$GLOBALS['http_error'];
    return $res;
}

function opcGetStatus() {
    global $osrv;
    global $opc_requests;

    $xml=opcRequest(&$osrv["path"],&$opc_requests["GetStatus"]);
    if (!$xml) return;
    
    parser_init();
    parse($xml);
    parser_free();
    
    $GLOBALS['xml_request']=&$opc_requests["GetStatus"];
    $GLOBALS['xml_response']=&$xml;
}

function opcBrowse() {
    global $osrv;
    global $opc_requests;
    global $reply;
    
    $xml=opcRequest(&$osrv["path"],&$opc_requests["Browse"]);
    if (!$xml) return;

    parser_init();
    parse($xml);
    parser_free();
    
    $GLOBALS['xml_request'].=$opc_requests["Browse"];
    $GLOBALS['xml_response'].=$xml;

    while (parseBoolean($reply["MOREELEMENTS"])) {
	$nreq=return_with_continuationpoint($opc_requests["Browse"],$reply["CONTINUATIONPOINT"]);
	
	$xml=opcRequest(&$osrv["path"],$nreq);
	if (!$xml) return;
	
	parser_init();
	parse($xml);
	parser_free();

	$GLOBALS['xml_request'].=$nreq;
	$GLOBALS['xml_response'].=$xml;
    }

}

function opcRead() {
    global $osrv;
    global $opc_requests;

    $xml=opcRequest(&$osrv["path"],&$opc_requests["Read"]);
    if (!$xml) return;

    parser_init();
    parse($xml);
    parser_free();
    
    $GLOBALS['xml_request']=&$opc_requests["Read"];
    $GLOBALS['xml_response']=&$xml;
}

function opcConfigure() {
    global $HTTP_COOKIE_VARS;
    global $opc_servers;

    $i=opcServer();
    if ($i>=0) {
	$GLOBALS['osrv']=&$opc_servers[$i];
	$md5=md5($GLOBALS['osrv']);
	$GLOBALS['lang']=$HTTP_COOKIE_VARS['lang' . $md5];
    } else unset($GLOBALS['osrv']);
}
opcConfigure();

require("opcreq.php");
?>