#define ALIGN(pos) \
    if (pos&3) pos = (pos&~3)+4;

char dime = 0;

char buffer[12];
char *name;
unsigned long namepos = 0;

FILE *f = NULL;
unsigned long buffered = 0;
unsigned long remains = 0;
unsigned long remainspad;
unsigned long skip = 0;

unsigned short optionslength;
unsigned short idlength;
unsigned short typelength;

char moredata=0;

size_t writefunc(char *ptr, size_t sizefake, size_t nmemb, void *stream) {
    long i;
    size_t size = nmemb;
    
    if (!dime) {
	if ((*(char*)ptr!=60)&&(*(char*)ptr!=32)) dime=1;
	else {
	    if (((char*)ptr)[2]!='D') dime=-1;
	    else dime=-2;
	}
    }
    
    if (dime<0) {
	return fwrite(ptr,sizefake,nmemb,(FILE*)stream);
    } else {
	unsigned long pos = 0;
	
//	printf("Size: %lu\n",size);
	moredata = 0;
	while (size>0) {
	    if (optionslength) {
		if (optionslength>size) {
		    optionslength-=size;
		    return nmemb;
		} else {
		    pos+=optionslength;
		    size-=optionslength;
		    optionslength = 0;
		}
	    }
	    
	    if (idlength) {
		if (idlength>size) {
		    memcpy(name+namepos, ptr+pos, size);
		    namepos+=size;
		    idlength -= size;
		    return nmemb;
		} else {
		    memcpy(name+namepos, ptr+pos, idlength);
		    name[namepos+idlength]=0;
		    if ((remains)&&(strcasecmp(name,"SOAP_message"))) {
			for (i=0;i<namepos+idlength;i++)
			    if (name[i]=='/') name[i]='_';

			f = fopen(name, "w");
		    }
		    free(name);
		    
		    pos+=idlength;
		    size-=idlength;
		    idlength = 0;
		}
		optionslength = typelength;
		continue;
	    }

	    if (remains) {
		if (remains>size) {
		    if (f) fwrite(ptr+pos, 1, size, f);
		    else fwrite(ptr+pos, 1, size, (FILE*)stream);
		    remains-=size;
		    return nmemb;
		}
		if (f) {
		    fwrite(ptr+pos, 1, remains, f);
		    fclose(f);
		    f = NULL;
		} else fwrite(ptr+pos, 1, remains, (FILE*)stream);
		size-=remains;
	        pos+=remains;
		remains = 0;
		optionslength = remainspad;
		continue;
	    }
	
	    if (size+buffered<12) {
		if (size) memcpy(buffer,ptr+pos,size);
		buffered = size;
		return nmemb;
	    }
	
	    memcpy(buffer+buffered, ptr+pos, 12-buffered);
	    size-=(12-buffered);
	    pos+=(12-buffered);
	    buffered = 0;
	    
	    optionslength=ntohs(*(uint16_t*)(buffer+2));
	    ALIGN(optionslength);
    
	    idlength=ntohs(*(uint16_t*)(buffer+4));
	    if (idlength) name = (char*)malloc(idlength+1);
	    
	    typelength=ntohs(*(uint16_t*)(buffer+6));
	    ALIGN(typelength);
	    if (idlength&3) typelength+=(4-idlength&3);

	    remains=ntohl(*(uint32_t*)(buffer+8));
	    if (remains&3) remainspad = 4 - remains&3;
	    else remainspad = 0;
	    
	    if ((*buffer)&64) {
		if (size) moredata = 1;
		else moredata=-1;
	    }
	    
	    namepos = 0;
//	    printf("Sizes: %lu %lu %lu\n",optionslength, idlength, typelength);
//	    printf("Data: %lu\n",remains);
	}
    } 
    if (moredata) moredata=-1;
    return nmemb;
}
