#ifndef _OPC_LOCALE_H
#define _OPC_LOCALE_H

#define MAX_CHARSET_CHARS 16

struct OPCLocaleT {
    char locale[6];
    char charset[MAX_CHARSET_CHARS+1];
};

typedef struct OPCLocaleT *OPCLocale;

OPCLocale opcLocaleCreate();
void opcLocaleDestroy(OPCLocale ctx);
void opcLocaleSetLocale(OPCLocale ctx, const char *locale);
void opcLocaleSetCharset(OPCLocale ctx, const char *charset);

#endif /* _OPC_LOCALE_H */
