#ifndef _OPC_MANAGER_H
#define _OPC_MANAGER_H

#include <opcmalloc.h>

typedef struct OPCManagerContextT *OPCManagerContext;



struct OPCManagerContextT {
    OPCMallocContext malloc;
    
    Queue
};

struct OPCManagerRequestPoolContextT {
};

GetRequest()
ReturnRequest()

struct OPCManagerRequestContextT {
    OPCDataInfo info;
    OPCDataRepresentation representation;
    OPCUserData user_data;
    ...;
    
    OPCManagerRequest next;			/* If multiple values, sorted by time */
};


OPCManagerContext opcManagerCreateContext(OPCMallocContext mctx);
int opcManagerInitContext(OPCManagerContext ctx);
void opcManagerFreeContext(OPCManagerContext ctx);
void opcManagerDestroyContext(OPCManagerContext ctx);



opcManagerCreateRequest();

int opcManagerRequest(
    OPCManagerContext ctx, 		/* Request Manager */
    OPCItemContext item, 		/* Data Source */
    OPCDate start, 			/* Earliest data required */
    OPCDate deadline, 			/* Response Deadline */
    unsigned char all, 			/* 0 - latest value, 1 - all data in cache, 2 - all data */
    unsigned long repid,		/* Data Representation */
    OPCRequestOptions options,		/* Request Options */
    OPCProcessing *result);		/* Result will be put here */




#endif /* _OPC_MANAGER_H */

