<?function isAlphaNum($str)
{
	if (preg_match("/[^A-Za-z0-9\.\\\\\/]/",$str)) return false;
	else return true;
}

function page_check($page) {
	if (!isAlphaNum($page)) return true;
	if (strlen($page)>1024) return true;
	if ($page{i}=='/') return true;
	if (substr_count($page,"..")) return true;
	@$fp=fopen($page,"r");
	if (!$fp) return true;
	$line=fgets($fp,4096);
	if (preg_match("/^<\?(php)?\s*#subpage/i",$line)) $ret=false;
	else $ret=true;
	fclose($fp);
	return $ret;
}

function include_page() {
    global $HTTP_GET_VARS;
    
    if (($HTTP_GET_VARS['page'])&&(page_check($HTTP_GET_VARS['page']))) {
	return false;	
    } else {
	if ($HTTP_GET_VARS['page']) {
	    if (!substr_count($HTTP_GET_VARS['page'],".")) {
		$GLOBALS['pagefunc']=create_function('','echo("<pre>");include(\'' . $HTTP_GET_VARS["page"] . '\');echo("</pre>");');
	    } else {
		include($HTTP_GET_VARS['page']);
		$GLOBALS['pagefunc']="start";
	    }
	}
	else {
	    include('about.php');
	    $GLOBALS['pagefunc']="start";
	}
    }
    return true;
}


function print_xml($xml) {
//    print("<pre>" . htmlentities($xml) . "</pre>");
    echo "<pre>";
    $items=preg_split('/>\s*</',$xml);
    
    $level=0;
    for ($i=0;$items[$i];$i++) {
	    // Skip <?xml lines for multi document xml
	if (preg_match("/^\s*<?\?xml/",$items[$i])) {
	    if (preg_match("/^\s*\?xml/",$items[$i])) continue;
	    echo htmlentities($items[$i]);
	    if ($items[$i+1]) echo htmlentities(">\n");
	    continue;
	}


	if (($items[$i+1])&&(preg_match("/^\s*</",$items[$i+1]))) $tf=1;
	else $tf=0;

	if (preg_match("|^\s*/|",$items[$i])) $level--;

//	if (preg_match(/
	echo "\n";
	for ($j=0;$j<$level;$j++) echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	
	if ($i>0) echo htmlentities("<");
	echo htmlentities($items[$i]);
	if ($items[$i+1]) echo htmlentities(">");

	if (preg_match("|^[^/]*\w|",$items[$i])) {
	    if (preg_match("|/[:\w]*$|",$items[$i])) ;
	    else $level++;
	}
    }
    echo "</pre>";
}

?>