<?

$reply = array();
/* Modes:
0 - Off
1 - Reading string 
*/
$mode = 0;


function parseBoolean(&$attr) {
    if (($attr=="true")||($attr=="1")) return 1;
    else return 0;
}

function startElement($parser, $name, $attrs) {
    global $namespace;
    global $reply;
    global $elements;
    global $mode;
    
    if (!preg_match("|${namespace}:([^:]*)|i",$name,$m)) return;
    $tag=&$m[1];
    
    switch($tag) {
	case "BROWSERESPONSE":
	    foreach ($attrs as $key => $value) {
		$reply[$key]=$value;
	    }
	break;
	case "STATUS":
	case "GETSTATUSRESULT":
	case "BROWSERESULT":
	case "READRESULT":
	    foreach ($attrs as $key => $value) {
		$reply[$key]=$value;
	    }
	break;
	case "STATUSINFO":
	case "VENDORINFO":
	    $reply[$tag]="";
	    $GLOBALS["xmlstring"]=&$reply[$tag];
	    $mode=1;
	break;
	case "SUPPORTEDLOCALEIDS":
	case "SUPPORTEDINTERFACEVERSIONS":
	    if (!is_array($reply[$tag])) $reply[$tag]=array();
	    $reply[$tag][]="";
	    $GLOBALS["xmlstring"]=&$reply[$tag][count($reply[$tag])-1];
	    $mode=1;
	break;
	case "ELEMENTS":
	    if ($attrs["ITEMPATH"]) $element["FullName"]=$attrs["ITEMPATH"] . "/" . $attrs["ITEMNAME"];
	    else $element["FullName"]=$attrs["ITEMNAME"];
	    $element["Title"]=$attrs["NAME"];
	
	    $element["IsItem"]=parseBoolean($attrs["ISITEM"]);
	    $element["HasChilds"]=parseBoolean($attrs["HASCHILDREN"]);
	    $elements[]=&$element;
	break;
    }
}

function endElement($parser, $name) {
    global $mode;
    
    switch ($mode) {
	case 1:
	    $mode=0;
	break;
    }
}

# Can be called twice or more for one text item
# Get data by reference ?
function textElement($parser, $data) {
    global $xmlstring;
    global $mode;
    
    switch ($mode) {
	case 1: 
	    $xmlstring.=$data;
	break;
    }
}


function parser_init() {
    global $xml_parser;

    $xml_parser = xml_parser_create_ns("UTF-8");
    xml_set_element_handler($xml_parser, "startElement", "endElement");
    xml_set_character_data_handler($xml_parser, "textElement");
}

function parser_free() {
    global $xml_parser;

    xml_parser_free($xml_parser);
}

function parse(&$xml,$is_final=1) {
    global $xml_parser;
    
    if (!xml_parse($xml_parser,$xml,$is_final)) {
	return "Invalid XML response message from OPC XML-DA server. " . xml_error_string(xml_get_error_code($xml_parser));
    }
#    print_r($GLOBALS["reply"]);
    return null;
}
?>